<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/29/2003 *
 * ===============                              Last change: 01/16/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : fatal_errors.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Outputs fatal errors                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Gibt fatale Fehler aus                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

if (getTotalFatalErrors() > 0) {
	// Main div container
	LOAD_TEMPLATE("fatal_header");

	// Set unset variable
	if (empty($check)) $check = '';
	if ((isInstalling()) || (!isInstalled())) {
		// While we are installing ouput other header than while it is installed... :-)
		$OUT = '';
		foreach (getFatalArray() as $key => $value) {
			// Prepare content for the template
			$content = array(
				'key'   => ($key + 1),
				'value' => $value
			);

			// Load row template
			$OUT .= LOAD_TEMPLATE("install_fatal_row", true, $content);
		}

		// Load main template
		LOAD_TEMPLATE("install_fatal_table", false, $OUT);
	} elseif (isInstalled()) {
		// Display all runtime fatal errors
		$OUT = '';
		foreach (getFatalArray() as $key => $value) {
			// Prepare content for the template
			$content = array(
				'key'   => ($key + 1),
				'value' => $value
			);

			// Load row template
			$OUT .= LOAD_TEMPLATE("runtime_fatal_row", true, $content);
		}

		// Load main template
		LOAD_TEMPLATE("runtime_fatal_table", false, $OUT);

		// Abort here
		shutdown();
	}

	// Message to regular users (non-admin)
	$CORR = getMessage('FATAL_REPORT_ERRORS');

	// PHP warnings fixed
	if ($check == "done") {
		if (IS_ADMIN()) $CORR = getMessage('FATAL_CORRECT_ERRORS');
	} // END - if

	// Load footer template
	LOAD_TEMPLATE("fatal_footer", false, $CORR);
}

//
?>
