<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/28/2004 *
 * ================                             Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_links.php                              *
 * -------------------------------------------------------------------- *
 * Short description : List unconfirmed mails of a member               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Unbestaetigte Mails eines Mitgliedes auflisten   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!EXT_IS_ACTIVE('mailid')) {
	addFatalMessage(__FILE__, __LINE__, sprintf(getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'mailid'));
	return;
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

if (!REQUEST_ISSET_GET('del')) REQUEST_SET_GET('del', '');

if (REQUEST_ISSET_GET('uid')) {
	// Check if the user already exists
	$result = SQL_QUERY_ESC("SELECT surname, family, email FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
		array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);

	 // Is there an entry?
	if (SQL_NUMROWS($result) == 1) {
		// Loads surname, family's name and the email address
		list($sname, $fname, $email) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Grab user's all unconfirmed mails
		if (EXT_IS_ACTIVE('bonus')) {
			// Load bonus ID
			$result = SQL_QUERY_ESC("SELECT stats_id, bonus_id, link_type FROM `{!_MYSQL_PREFIX!}_user_links` WHERE userid=%s ORDER BY `id`",
				array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
		} else {
			// Load stats ID (2nd will be ignored later! But it is needed for the same fetchrow command)
			$result = SQL_QUERY_ESC("SELECT stats_id, stats_id, link_type FROM `{!_MYSQL_PREFIX!}_user_links` WHERE userid=%s ORDER BY `id`",
				array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
		}

		// Get number of rows from the query
		$nums = SQL_NUMROWS($result);

		if ($nums > 0) {
			// Some unconfirmed mails left
			if (REQUEST_GET('del') == "all") {
				// Delete all unconfirmed mails by this user
				SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_user_links` WHERE userid=%s LIMIT %s",
					array(bigintval(REQUEST_GET('uid')), $nums), __FILE__, __LINE__);

				// Prepare mail and send it away
				$msg = LOAD_EMAIL_TEMPLATE("admin-del_links", $nums, bigintval(REQUEST_GET('uid')));
				SEND_EMAIL($email, getMessage('ADMIN_DEL_LINK_SUBJ'), $msg);

				// Display message
				LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_LINKS_DELETED'));
			} else {
				// Init variables
				$OUT = ''; $SW = 2;

				// List all unconfirmed mails
				// @TODO Find a way to rewrite this. See some lines above for different queries
				while (list($id, $id2, $type) = SQL_FETCHROW($result)) {
					// Initializes some variables
					$cat = '';
					$DATA = '';
					$PROBLEM = getMessage('GENERAL_MAIL_PROBLEM');
					$result_data = false; // Closes Bug #58

					// Load data from stats table...
					switch ($type)
					{
					case "NORMAL":
						$result_data = SQL_QUERY_ESC("SELECT subject, timestamp_ordered, cat_id FROM `{!_MYSQL_PREFIX!}_user_stats` WHERE id=%s LIMIT 1",
							array(bigintval($id)), __FILE__, __LINE__);
						$type = 'mailid'; $DATA = $id; $PROBLEM = getMessage('NORMAL_MAIL_PROBLEM');
						$LINK = "<a href=\"{!URL!}/mailid.php?uid=".REQUEST_GET('uid')."&amp;mailid=".$id."\" target=\"_blank\">".$id."</a>";
						break;

					case "BONUS":
						$result_data = SQL_QUERY_ESC("SELECT subject, timestamp, cat_id FROM `{!_MYSQL_PREFIX!}_bonus` WHERE id=%s LIMIT 1",
							array(bigintval($id2)), __FILE__, __LINE__);
						$type = 'bonusid'; $DATA = $id2; $PROBLEM = getMessage('BONUS_MAIL_PROBLEM');
						$LINK = "<a href=\"{!URL!}/mailid.php?uid=".REQUEST_GET('uid')."&amp;bonusid=".$id2."\" target=\"_blank\">".$id2."</a>";
						break;

					default: // Problem in application detected!
						// Log the error
						DEBUG_LOG(__FILE__, __LINE__, sprintf("Invalid email type %s detected.", $type));
						break;
					}

					if (SQL_NUMROWS($result_data) == 1) {
						// Mail was found!
						list($subject, $timestamp, $cat) = SQL_FETCHROW($result_data);
						SQL_FREERESULT($result_data);
						if (empty($subject)) $subject = getMessage('DEFAULT_SUBJECT_LINE');

						// Prepare data for the row template
						$content = array(
							'sw'    => $SW,
							'link'  => $LINK,
							'subj'  => $subject,
							'stamp' => MAKE_DATETIME($timestamp, "0"),
							'cat'   => GET_CATEGORY($cat),
						);

						// Load row template
						$OUT .= LOAD_TEMPLATE("admin_list_links_row", true, $content);
					} else {
						// Load template for error
						$OUT .= LOAD_TEMPLATE("admin_list_links_problem",
							array(
								'sw'		=> $SW,
								'problem'	=> $PROBLEM,
								'data'		=> $DATA
							)
						);
					}
					$SW = 3 - $SW;
				}

				// Free memory
				SQL_FREERESULT($result);

				// Remember list in constant for the template
				define('__SNAME_VALUE', $sname);
				define('__FNAME_VALUE', $fname);
				define('__EMAIL_VALUE', "<a href=\"".CREATE_EMAIL_LINK($email, "user_data")."\">".$email."</a>");
				define('__EMAIL_LIST' , $OUT);
				define('__NUMS_VALUE' , $nums);
				define('__UID'        , bigintval(REQUEST_GET('uid')));

				// Load final template
				LOAD_TEMPLATE("admin_list_links");
			}
		} else {
			// No mails left to confirm
			LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('ADMIN_MEMBER_LINKS'), REQUEST_GET('uid')));
		}
	} else {
		// User not found
		LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('ADMIN_MEMBER_404'), REQUEST_GET('uid')));
	}
} else {
	// Output selection form with all confirmed user accounts listed
	ADD_MEMBER_SELECTION_BOX();
}

//
?>
