<?php
/************************************************************************
 * M-XChange v0.2.1                                   Start: 04/24/2005 *
 * ================                             Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-lock_sponsor.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Edit sponsor account                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sponsorenaccount aendern                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);
$message = '';

if (REQUEST_ISSET_GET(('id'))) {
	// Check for selected sponsor
	$result = SQL_QUERY_ESC("SELECT gender, surname, family, email, status FROM `{!_MYSQL_PREFIX!}_sponsor_data` WHERE id='%s' LIMIT 1",
	 array(bigintval(REQUEST_GET('id'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Get sponsor's current status and let only confirmed and locked status pass
		list($gender, $sname, $fname, $email, $status) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		if (($status == "CONFIRMED") || ($status == "LOCKED")) {
			// Transfer data to constants
			define('__GENDER'  , TRANSLATE_GENDER($gender));
			define('__SURNAME', $sname);
			define('__FAMILY' , $fname);
			define('__ID'     , bigintval(REQUEST_GET('id')));

			if (IS_FORM_SENT()) {
				// Create messages
				if ($status == "CONFIRMED") {
					// Message when sponsor's account got lock
					define('__EMAIL_MSG', getMessage('SPONSOR_ACCOUNT_LOCKED'));
					$subject = getMessage('SPONSOR_SUBJECT_LOCKED');
					$status = "LOCKED";
				} else {
					// Message when sponsor's account got unlock
					define('__EMAIL_MSG', getMessage('SPONSOR_ACCOUNT_UNLOCKED'));
					$subject = getMessage('SPONSOR_SUBJECT_UNLOCKED');
					$status = "CONFIRMED";
				}

				// Load email message
				$msg = LOAD_EMAIL_TEMPLATE("lock_sponsor", REQUEST_POST('reason'), bigintval(REQUEST_GET('id')));

				// And send it away
				SEND_EMAIL($email, $subject, $msg);

				// Update sponsor's account
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_sponsor_data` SET `status`='".$status."' WHERE id='%s' LIMIT 1",
					array(bigintval(REQUEST_GET('id'))), __FILE__, __LINE__);
			} elseif (REQUEST_ISSET_POST(('no'))) {
				// No don't lock / unlock now!
				LOAD_URL('modules.php?module=admin&amp;what=list_sponsor&amp;id='.bigintval(REQUEST_GET('id')));
			} else {
				// Create header and text messages
				if ($status == 'CONFIRMED') {
					// Messages when sponsor's account is confirmed
					define('__HEADER_MESSAGE', getMessage('SPONSOR_LOCK_SPONSOR_HEADER'));
					define('__TEXT_MESSAGE'  , getMessage('SPONSOR_LOCK_SPONSOR_TEXT'));
				} else {
					// Messages when sponsor's account is locked
					define('__HEADER_MESSAGE', getMessage('SPONSOR_UNLOCK_SPONSOR_HEADER'));
					define('__TEXT_MESSAGE'  , getMessage('SPONSOR_UNLOCK_SPONSOR_TEXT'));
				}

				// Create email link
				define('__EMAIL_LINK', '<a href="mailto:' . $email . '">{!__GENDER!} {!__SURNAME!} {!__FAMILY!}</a>');

				// Display form
				LOAD_TEMPLATE('admin_lock_sponsor');
			}
		} else {
			// Cannot change status on unconfirmed or pending accounts!
			$message = getMessage('ADMIN_SPONSPOR_CANNOT_LOCK_PENDING_UNCINFIRMED_ACCOUNTS');
		}
	} else {
		// Sponsor not found!
		$message = sprintf(getMessage('ADMIN_SPONSOR_404'), bigintval(REQUEST_GET('id')));
	}
} else {
	// Not called by what-list_sponsor.php
	$message = getMessage('ADMIN_CALL_NOT_DIRECTLY');
}

if (!empty($message)) {
	// Output message
	LOAD_TEMPLATE('admin_settings_saved', false, $message);
}

//
?>
