<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/29/2003 *
 * ===============                              Last change: 01/06/2006 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : order.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Submits your order to the administrators         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet die Buchung an die Administratoren        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
$URL = '';
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif ((!EXT_IS_ACTIVE('order')) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, sprintf(getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'order'));
	return;
} elseif (!IS_MEMBER()) {
	// Sorry, no guest access!
	$URL = 'modules.php?module=index';
} elseif (!REQUEST_ISSET_GET(('order'))) {
	// You cannot call this module directly!
	$URL = 'modules.php?module=login&amp;what=order';
}

// When URL is empty nothing bad happend here
if (empty($URL)) {
	// Is the auto-send mechanism active or inactive?
	if (getConfig('autosend_active') == 'Y') {
		// Auto-send is active
		define('ADMIN_AUTOSEND',  getMessage('ADMIN_AUTOSEND_ACTIVE'));
		define('MEMBER_AUTOSEND', getMessage('MEMBER_AUTOSEND_ACTIVE'));
		$type = 'NEW';
	} else {
		// Auto-send is inactive
		define('ADMIN_AUTOSEND',  getMessage('ADMIN_AUTOSEND_INACTIVE'));
		define('MEMBER_AUTOSEND', getMessage('MEMBER_AUTOSEND_INACTIVE'));
		$type = 'ADMIN';
	}

	// Update sending pool
	SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_pool` SET data_type='%s' WHERE id=%s AND sender=%s AND data_type='TEMP' LIMIT 1",
		array($type, bigintval(REQUEST_GET('order')), getUserId()), __FILE__, __LINE__);

	// Finally is the entry valid?
	if (SQL_AFFECTEDROWS() == 1) {
		// Load personal data...
		$result = SQL_QUERY_ESC("SELECT gender, surname, family, email FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
			array(getUserId()), __FILE__, __LINE__);
		list($gender, $sname, $fname, $email) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Load mail again...              0       1        2           3          4      5      6         7
		$result = SQL_QUERY_ESC("SELECT subject, text, receivers, payment_id, timestamp, url, cat_id, target_send FROM `{!_MYSQL_PREFIX!}_pool` WHERE id=%s AND sender=%s LIMIT 1",
			array(bigintval(REQUEST_GET('order')), getUserId()), __FILE__, __LINE__);
		$DATA = SQL_FETCHROW($result);
		SQL_FREERESULT($result);
		if (empty($DATA[0])) $DATA[0] = getMessage('DEFAULT_SUBJECT_LINE');

		// Calculate used points
		$USED = $DATA[7] * GET_PAY_POINTS($DATA[3]);

		// Update used points
		$add = '';
		if (getConfig('order_max_full') == 'ORDER') $add = ', mail_orders=mail_orders+1';
		SUB_POINTS('order', getUserId(), $USED);

		// Prepare content
		$content = array(
			'blocks'   => getConfig('max_send'),
			'subject'  => $DATA[0],
			'text'     => $DATA[1],
			'payment'  => GET_PAYMENT($DATA[3]),
			'category' => GET_CATEGORY($DATA[6]),
			'url'      => $DATA[5]
		);

		// Send an email to the user
		$msg_mem = LOAD_EMAIL_TEMPLATE('order-member', $content, getUserId());
		SEND_EMAIL($email, getMessage('MEMBER_NEW_QUEUE'), $msg_mem);

		// Notify admins about this
		SEND_ADMIN_NOTIFICATION(getMessage('ADMIN_NEW_QUEUE'), 'order-admin', $content, getUserId());

		// Output back bottom
		LOAD_TEMPLATE('member_order-back', false);
	} else {
		// Matching line not found or already 'placed' in send queue
		LOAD_URL('modules.php?module=login');
	}
} else {
	// Redirect...
	LOAD_URL($URL);
}

//
?>
