<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/04/2005 *
 * ===============                              Last change: 03/04/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : monthly_newsletter.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Monthly check for newsletter unsubscriptions     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Monatlicher Test auf Newsletter-Abmeldungen      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!EXT_IS_ACTIVE('newsletter')) {
	return;
}

// Do not execute when script is in CSS mode or no daily reset
if (($GLOBALS['output_mode'] == 1) || (!isResetModeEnabled())) return;
//* DEBUG: */ echo basename(__FILE__)."<br />\n";

// Get current month (2 digits)
$curr = date("m", time());

if (getConfig('last_month') != $curr) {
	// Check for unsubscribed members
	$result = SQL_QUERY("SELECT userid, email, nl_until FROM `{!_MYSQL_PREFIX!}_user_data` WHERE nl_receive='N' ORDER BY userid", __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Some unsubscriptions are found so we reset them to receive newsletters
		while ($content = SQL_FETCHARRAY($result)) {
			// Update account
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET nl_receive='Y', nl_until='0' WHERE userid=%s LIMIT 1",
				array(bigintval($content['userid'])), __FILE__, __LINE__);

			// Send email to him
			$msg = LOAD_EMAIL_TEMPLATE("member_newsletter_reset", true, bigintval($content['userid']));
			SEND_EMAIL($content['email'], getMessage('NL_MEMBER_RESET_SUBJECT'), $msg);

			// Send email to admin
			SEND_ADMIN_NOTIFICATION(getMessage('NL_ADMIN_SUBJECT'), "admin_newsletter_reset", array(), getUserId());
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	}
}

//
?>
